/**********************************************************************************
 * $URL: https://source.sakaiproject.org/svn/kernel/trunk/kernel-util/src/main/java/org/sakaiproject/util/SingleStorageSqlDb2.java $
 * $Id: SingleStorageSqlDb2.java 101656 2011-12-12 22:40:28Z aaronz@vt.edu $
 ***********************************************************************************
 *
 * Copyright (c) 2007, 2008 Sakai Foundation
 *
 * Licensed under the Educational Community License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 **********************************************************************************/

package org.sakaiproject.util;

/**
 * methods for accessing single storage data in a db2 database.
 */
public class SingleStorageSqlDb2 extends SingleStorageSqlDefault
{
   /**
    * returns the sql statement which retrieves the xml field from the specified table and limits the result set.
    */
   public String getXmlSql(String field, String table, int first, int last)
   {
      return "with TEMP_QUERY as (select XML, ROW_NUMBER() over (order by " + field + ") as rank from " + table
            + ") select XML from TEMP_QUERY where rank between ? and ?";
   }
}
